
; Public Domain

; test run command: ; .; .

%include "lmacros3.mac"
%include "eld.mac"
%include "eldcall.mac"
%include "elddata.mac"

	cpu 8086

	addsection RELOCATEDDATA, nobits vstart=_ELD_RELOC_VSTART
relocateddata:

	addsection HEADER, start=0

	istruc ELD_HEADERX
at eldhxHeader
		; ELD executable header
	istruc ELD_HEADER
at eldhSignature,	db "ELD1"
			db 0,0,0
			db 26
at eldhCodeOffset,	dd CODEOFFSET
at eldhCodeImageLength,	dw code_size
at eldhCodeAllocLength,	dw 0
at eldhDataOffset,	dd DATAOFFSET
at eldhDataImageLength,	dw data_size
at eldhDataAllocLength,	dw total_data_size - data_size
at eldhCodeEntrypoint,	dw linker - code
at eldhReserved
at eldhExtensionSize,	dw header_extension_end - $$
	iend
at eldhxDescriptionOffset,	dd description
header_extension_end:
	iend

description:		asciz "Display DOS DPB."


	align 16, db 0

CODEOFFSET equ $ - $$
	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
%define CODEFIXUP - code + 0
code:
		; ELD instance header
	istruc ELD_INSTANCE
at eldiStartCode
at eldiEndCode
at eldiStartData
at eldiEndData
at eldiIdentifier,	fill 8, 32, db "DPB"
	iend


start:
	mov bx, es
	 push ss
	 pop es
	extcallcall skipcomma

	extcallcall InDOS
	jz @F
.error:
	extcallcall error

@@:

	xor dl, dl
	extcallcall iseol?
	je .get
	cmp byte [si], ':'
	jne .number
	extcallcall uppercase
	mov dl, al
	sub dl, 'A'
	cmp dl, 32
	jae .number
	inc dx
	inc si
	lodsb
	extcallcall chkeol
	jmp .get

.number:
	extcallcall getbyte
	extcallcall chkeol
.get:
	xor bx, bx
	mov ax, 32FFh
	extcallcall ispm
	jnz .86mode
.pm:
subcpu 286
	push word [relocateddata]
linkdatarelocation pspdbg		; es
	push word [relocateddata]
linkdatarelocation pspdbg		; ds
	push word 21h
	push bp
	call intcall_return_parameter_es_parameter_ds
	pop dx				; get ds
	pop cx				; (discard es)
	extcallcall setes2dx		; es => DPB
	push ds
	push es
	pop ds
	pop es				; swap ds, es
subcpureset
	db __TEST_IMM16			; (skip int)
.86mode:
	int 21h


%if 0
Format of DOS Drive Parameter Block:
Offset	Size	Description	(Table 01395)
 00h	BYTE	drive number (00h = A:, 01h = B:, etc)
 01h	BYTE	unit number within device driver
 02h	WORD	bytes per sector
 04h	BYTE	highest sector number within a cluster
 05h	BYTE	shift count to convert clusters into sectors
 06h	WORD	number of reserved sectors at beginning of drive
 08h	BYTE	number of FATs
 09h	WORD	number of root directory entries
 0Bh	WORD	number of first sector containing user data
 0Dh	WORD	highest cluster number (number of data clusters + 1)
		16-bit FAT if greater than 0FF6h, else 12-bit FAT
---DOS 4.0-6.0---
 0Fh	WORD	number of sectors per FAT
 11h	WORD	sector number of first directory sector
 13h	DWORD	address of device driver header (see #01646)
 17h	BYTE	media ID byte (see #01356)
 18h	BYTE	00h if disk accessed, FFh if not
 19h	DWORD	pointer to next DPB
 1Dh	WORD	cluster at which to start search for free space when writing,
		usually the last cluster allocated
 1Fh	WORD	number of free clusters on drive, FFFFh = unknown
%endif

	struc DPB
dpbDrive:			resb 1
dpbDeviceUnit:			resb 1
dpbBytesPerSector:		resw 1
dpbHighestSectorInCluster:	resb 1
dpbSectorsPerClusterShift:	resb 1
dpbReservedSectors:		resw 1
dpbAmountFATs:			resb 1
dpbAmountRootEntries:		resw 1
dpbDataStart:			resw 1
dpbMaximumCluster:		resw 1
dpbSectorsPerFAT:		resw 1
dpbRootStart:			resw 1
dpbDeviceHeader:		resd 1
dpbMediaID:			resb 1
dpbAccessed:			resb 1
dpbNext:			resd 1
dpbFreeClusterNext:		resw 1
dpbAmountFreeClusters:		resw 1
	endstruc


	mov dx, msg.return
internaldatarelocation
	mov di, msg.return.code
internaldatarelocation
	extcallcall hexbyte

	mov di, buffer
internaldatarelocation
	mov si, bx
	mov cx, DPB_size
	rep movsb

	push ss
	pop ds
	extcallcall putsz

	cmp al, 0
	jne .end

	mov si, table
internaldatarelocation

.loop:
	lodsw
	test ax, ax
	jz .end
	xchg bx, ax

	lodsw
	xchg cx, ax

	mov ax, word [bx]
	mov dx, word [bx + 2]

	mov di, relocateddata
linkdatarelocation line_out

	cmp cl, 2
	jb .byte
	je .word
.dword:
	xchg ax, dx
	extcallcall hexword
	mov byte [di], '_'
	inc di
	xchg ax, dx
	extcallcall hexword

	mov word [di], 2020h
	scasw
	extcallcall decdword
	jmp @FF

.word:
	extcallcall hexword
	jmp @F

.byte:
	extcallcall hexbyte

	mov ah, 0
@@:
	mov word [di], 2020h
	scasw
	extcallcall decword
@@:

	lodsw
	xchg dx, ax
	extcallcall putsz
	extcallcall putsline_crlf
	jmp .loop

.end:
	call uninstall_oneshot
	xor ax, ax
	retf


uninstall_oneshot:
	testopt [ss:relocateddata], 1
linkdatarelocation options7, -3
	jnz @F

	mov ax, word [cs:code + eldiEndCode]
internalcoderelocation
	sub ax, word [cs:code + eldiStartCode]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used

	mov ax, word [cs:code + eldiEndData]
internalcoderelocation
	sub ax, word [cs:code + eldiStartData]
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extdata_used
@@:
	retn


subcpu 286
intcall_return_parameter_es_parameter_ds:
	lframe near
	lpar word, es_value
	lpar word, ds_value
	lpar_return
	lpar word, int_number
	lpar word, bp_value
	lvar 32h, 86m_call_struc
	lenter
	push es
	mov word [bp + ?86m_call_struc +00h], di	; edi
	mov word [bp + ?86m_call_struc +04h], si	; esi
	mov word [bp + ?86m_call_struc +10h], bx	; ebx
	mov word [bp + ?86m_call_struc +14h], dx	; edx
	mov word [bp + ?86m_call_struc +18h], cx	; ecx
	mov word [bp + ?86m_call_struc +1Ch], ax	; eax
	mov ax, word [bp + ?bp_value]
	mov word [bp + ?86m_call_struc +08h], ax	; bp
	mov al, 0					; (preserve flags!)
	lahf
	xchg al, ah
	mov word [bp + ?86m_call_struc +20h], ax	; flags
	xor ax, ax
	mov word [bp + ?86m_call_struc +0Ch + 2], ax
	mov word [bp + ?86m_call_struc +0Ch], ax
	mov word [bp + ?86m_call_struc +2Eh], ax	; sp
	mov word [bp + ?86m_call_struc +30h], ax	; ss
	mov ax, word [bp + ?es_value]			; usually [pspdbg]
	mov word [bp + ?86m_call_struc +22h], ax	; es
	mov ax, word [bp + ?ds_value]			; usually [pspdbg]
	mov word [bp + ?86m_call_struc +24h], ax	; ds
	push ss
	pop es				; => stack
	lea di, [bp + ?86m_call_struc]	; -> 86-Mode call structure
	testopt [relocateddata], 8000h
linkdatarelocation internalflags, -3
	jz @F
subcpu 386
	movzx edi, di			; (previously checked b[dpmi32] here)
subcpureset
@@:

	mov bx, word [bp + ?int_number]			; int#
	xor cx, cx
	mov ax, 0300h
	int 31h
	mov ah, byte [bp + ?86m_call_struc +20h]	; flags
	sahf
	mov di, word [bp + ?86m_call_struc +00h]	; edi
	mov si, word [bp + ?86m_call_struc +04h]	; esi
	mov bx, word [bp + ?86m_call_struc +10h]	; ebx
	mov dx, word [bp + ?86m_call_struc +14h]	; edx
	mov cx, word [bp + ?86m_call_struc +18h]	; ecx
	mov ax, word [bp + ?86m_call_struc +1Ch]	; eax
	push word [bp + ?86m_call_struc +22h]		; return es value
	pop word [bp + ?es_value]			;  in the parameter
	push word [bp + ?86m_call_struc +24h]		; return ds value
	pop word [bp + ?ds_value]			;  in the parameter
	pop es
	lleave
	lret
subcpureset


DATAOFFSET equ CODEOFFSET + code_size
	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
%define DATAFIXUP - datastart + 0
datastart:

%define NAMES db ""

%imacro item 2.nolist
	dw buffer + dpb%1
internaldatarelocation
	dw %2
	dw %%name
internaldatarelocation
 %defstr %%string %1
 %xdefine NAMES NAMES, %%name:, {fill 28,32,db %%string}, db 0
%endmacro

%imacro dumpnames 1-*.nolist
 %rep %0
	%1
  %rotate 1
 %endrep
%endmacro

	align 2, db 0
table:
item Drive,			1
item DeviceUnit,		1
item BytesPerSector,		2
item HighestSectorInCluster,	1
item SectorsPerClusterShift,	1
item ReservedSectors,		2
item AmountFATs,		1
item AmountRootEntries,		2
item DataStart,			2
item MaximumCluster,		2
item SectorsPerFAT,		2
item RootStart,			2
item DeviceHeader,		4
item MediaID,			1
item Accessed,			1
item Next,			4
item FreeClusterNext,		2
item AmountFreeClusters,	2
	dw 0

msg:
.return:	db "DOS function 32h call returned al="
.return.code:	asciz "--h.",13,10

dumpnames NAMES

uinit_data: equ $

	align 16, db 0
data_size equ $ - datastart

	absolute uinit_data

	alignb 2
buffer:		resb DPB_size

	alignb 16
uinit_data_end:

total_data_size equ $ - datastart
%assign _DATA_SIZE total_data_size

	usesection CODE

%include "eldlink.asm"

	align 16
code_size equ $ - code
